#!/usr/bin/env python

class A:
    def __init__(self, x):
        self.x = x

    def a(self):
        return self.x

class B(A):
    def b(self):
        return 2

class C(A, B):
    def a(self):
        return self.y

    def b(self):
        return self.a()

    def c(self):
        return A.a(self)

    def __init__(self, x, y):
        self.x = x
        self.y = y

class D:
    def __init__(self, y):
        self.z = y

    def a(self):
        return self.z

class E(C, D):
    pass

class F(A, D):
    pass

a = A(1)
b = B(1)
c = C(1, 2)
d = D(3)
e = E(3, 4)
f = F(5)

result1_1 = a.a()
result1_2 = b.b()
result2_2 = c.a()
result3_2 = c.b()
result2_1 = c.c()
result_3 = d.a()
result_4 = e.a()
result_5 = f.a()

# vim: tabstop=4 expandtab shiftwidth=4
